---
title: Event.timeStamp
slug: Web/API/Event/timeStamp
tags:
  - API
  - DOM
  - Event
  - Property
  - Reference
  - timeStamp
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>timeStamp</strong></code> read-only property of the {{domxref("Event")}} interface returns the time (in milliseconds) at which the event was created.</p>

<div class="notecard note">
<p><strong>Note:</strong> This property only works if the event system supports it for the particular event.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>time</em> = <em>event</em>.timeStamp;
</pre>

<h3 id="Value">Value</h3>

<p>This value is the number of milliseconds elapsed from the beginning of the current <a href="/en-US/docs/Web/API/Performance/timeOrigin">document's lifetime</a> till the event was created.</p>

<p>In newer implementations, the value is a {{domxref("DOMHighResTimeStamp")}} accurate to 5 microseconds (0.005 ms). In older implementations, the value is a {{domxref("DOMTimeStamp")}}, accurate to a millisecond.</p>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;
  Focus this iframe and press any key to get the
  current timestamp for the keypress event.
&lt;/p&gt;
&lt;p&gt;timeStamp: &lt;span id="time"&gt;-&lt;/span&gt;&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">function getTime(event) {
  var time = document.getElementById("time");
  time.firstChild.nodeValue = event.timeStamp;
}
document.body.addEventListener("keypress", getTime);</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", "100%", 100)}}</p>

<h2 id="Reduced_time_precision">Reduced time precision</h2>

<p>To offer protection against timing attacks and fingerprinting, the precision of <code>Event.timeStamp</code> might get rounded depending on browser settings.</p>

<p>In Firefox, the <code>privacy.reduceTimerPrecision</code> preference is enabled by default and defaults to 20us in Firefox 59; in 60 it will be 2ms.</p>

<pre class="brush: js notranslate">// reduced time precision (2ms) in Firefox 60
event.timeStamp;
// 1519211809934
// 1519211810362
// 1519211811670
// ...

// reduced time precision with `privacy.resistFingerprinting` enabled
event.timeStamp;
// 1519129853500
// 1519129858900
// 1519129864400
// ...
</pre>

<p>In Firefox, if you also enable <code>privacy.resistFingerprinting</code>, the precision will be 100ms or the value of <code>privacy.resistFingerprinting.reduceTimerPrecision.microseconds</code>, whichever is larger.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-event-timestamp", "Event.timeStamp")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Event.timeStamp")}}</p>
